<?php
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004-2008 ZoneO-soft, Butchu (email: "butchu" with the domain "zoneo.net")

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/



// We need those functions as well
include('Php/Functions/log_function.php');
include ("Php/config.php");
include ("Php/Functions/funct.country.inc.php");
include ("Php/Stats/statsMonthly.inc.php");

function formatRefString($ref,$engine_id,$engine_url,$engine_kwd,$engine_charset,$class="class=\"basic\"") {
global $strings;
global $domain;
$pos_domain = strpos($ref, $domain."/");
if (strlen(trim($ref)) == 0) return $strings['Directaccess'];
if ($pos_domain === false){
	$keywordsArray = phpTrafficA_ExtractKeywords($ref,$engine_id,$engine_url,$engine_kwd,$engine_charset,0);
	if ($keywordsArray != "") {
		// search engine 
		$how = 2;
		$engine = $keywordsArray[1];
		$keywords = phpTrafficA_cleanText($keywordsArray[0]);
		$keywords2 = shortenPage($keywords, 2);
		if($keywords2 != $keywords) $keywords2 .= "...";
		return "$engine: <a href=\"$ref\" $class target=\"_new\" rel=\"nofollow\">$keywords2</a>";
	} else {
		return urlLink($ref,2,$class);
	}
} else {
// $refString = "";
return "$domain: <a href=\"$ref\" title=\"$ref\" class=\"basic\" target=\"_new\" rel=\"nofollow\">".substr($ref, $pos_domain+strlen($domain), 30)."...</a>";
}
}

/*********************************************************************************/
/* Function: echoRecent
/* Role: latest access to the website
/* Parameters:
/*   - $c: connection to the database
/*   - $table: base name for sql tables
/*   - $site: root of the website,
/*   - $sort: parameter to use for sorting 
/*   - $order: in what order (ascending of descending)
/* Output:
/*   - nothing, but echos whatever it finds
/* Created: 06/2004
/* 11/2006: removed database connection function (moved earlier in the code)
/* 09/2007: shorten the output (group by IP)
/*          new parameters: $order and $sort
/*********************************************************************************/

function echoRecent($c,$table,$site,$sid, $sort, $order) {
global $DEBUG;
global $strings;
global $config_table;
global $lang;
global $ip2c;

// We read the config, we will need some of it
$conf = phpTrafficA_read_config($config_table, $c);
$os_id =  $conf['os_id'];
$os_label = $conf['os_label'];
$browser_id = $conf['browser_id'];
$browser_label = $conf['browser_label'];
$engine_id = $conf['engine_id'];
$engine_url = $conf['engine_url'] ;
$engine_kwd = $conf['engine_kwd'];
$engine_kwd = $conf['engine_kwd'];
$save_host = $conf['save_host'];
$engine_charset = $conf['engine_charset'];

$arrowsDate = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=latest&amp;lang=$lang&amp;sort=date", $strings['Sortby']." ".$strings['Dateandtime'], '');
$arrowsDuration = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=latest&amp;lang=$lang&amp;sort=dur", $strings['Sortby']." ".$strings['Duration'], '');
$arrowsIP = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=latest&amp;lang=$lang&amp;sort=IP", $strings['Sortby']." IP", '');
$arrowsHits = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=latest&amp;lang=$lang&amp;sort=hits", $strings['Sortby']." ".$strings['Hits'], '');
$arrowsPage = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=latest&amp;lang=$lang&amp;sort=page", $strings['Sortby']." ".$strings['Page'], '');
$arrowsReferrers = linksUpDown("./index.php?mode=stats&amp;sid=$sid&amp;show=latest&amp;lang=$lang&amp;sort=ref", $strings['Sortby']." ".$strings['Referrer'], '');

echo "<table class='stat'>
<tr class='title'><td colspan='9'>".$strings['Latestvisits']."</td></tr>
<tr class='caption'><td>&nbsp;</td><td>".$strings['Duration']."</td><td>IP</td><td>".$strings['Hits']."</td><td colspan=\"3\">&nbsp;</td><td>".$strings['Page']."</td><td>".$strings['Referrer']."</td></tr>
<tr class='caption'><td>$arrowsDate</td><td>$arrowsDuration</td><td>$arrowsIP</td><td>$arrowsHits</td><td colspan=\"3\">&nbsp;</td><td>$arrowsPage</td><td>$arrowsReferrers</td></tr>";

if ($sort == "dur") {
	$sortstring = "ORDER BY duration";
} else if ($sort == "IP") {
	$sortstring = "ORDER BY host";
} else if ($sort == "hits") {
	$sortstring = "ORDER BY hits";
} else if ($sort == "page") {
	$sortstring = "ORDER BY page";
} else if ($sort == "ref") {
	$sortstring = "ORDER BY ref";
} else {
	$sortstring = "ORDER BY startdate";
}
if ($order=="desc") {
	$sortstring .= " ASC";
} else {
	$sortstring .= " DESC";
}

$sql = "SELECT *, COUNT(*) as hits, MIN(date) as startdate, (UNIX_TIMESTAMP(MAX(date))- UNIX_TIMESTAMP(MIN(date))) as duration FROM ${table}_host  GROUP BY host $sortstring";
$res = mysql_query($sql,$c);
$n=0;
while ($row = mysql_fetch_object($res)) {
	$n+=1;
	$date =  date("M j G:i",strtotime($row->startdate));
	$duration = getTimeEn($row->duration);
	$ip = $row->host;
	$page = shortenPage($row->page);
	$ref = $row->ref;
	$agent = $row->agent;
	$hits = $row->hits;
	$country = ip2Country($ip,$ip2c);
	list($wb,$os)=split(";",phpTrafficA_ExtractAgent($agent,$browser_id,$browser_label,$os_id,$os_label));
	//if ($host == "") {
	//	$host = gethostbyaddr($ip);
	//	$sql2 = "UPDATE  `${table}_host` SET hostname=\"$host\" WHERE host=\"$ip\"";
	// echo "<br>Sql is $sql2";
	// $res2 = mysql_query($sql2,$c);
	// }
	// $refString = urlLink($ref,2);
	$refString = formatRefString($ref,$engine_id,$engine_url,$engine_kwd,$engine_charset);
	if (($n % 2) == 0) { $even = "even";} else {$even="odd";}
	echo "<tr class=\"data av $even\"><td nowrap>$date</td><td>&nbsp;$duration</td><td>&nbsp;<a href=\"./index.php?mode=stats&amp;sid=$sid&amp;show=clickstream&amp;lang=$lang&amp;ip=$ip\" title=\"".$strings['Moreinfovisitor']."\" class=\"basic\">$ip</a>&nbsp;</td><td align=\"center\">&nbsp;$hits&nbsp;</td><td>".countryFlag($country)."</td><td>".osImg($os,'')."</td><td>".browserImg($wb,$agent)."</td><td>$page</td><td>$refString</td></tr>\n";
}
if ($n==0) echo "<tr><td colspan=\"9\" align=\"center\">".$strings['Nothingyet']."</td></tr>\n";
echo "</table>";
}

function clickstream($c, $table, $site, $sid, $ip) {
global $strings;
global $config_table;
global $ip2c;
global $isLoggedIn;
global $lang;

// We read the config, we will need some of it
$conf = phpTrafficA_read_config($config_table, $c);
$os_id =  $conf['os_id'];
$os_label = $conf['os_label'];
$browser_id = $conf['browser_id'];
$browser_label = $conf['browser_label'];
$engine_id = $conf['engine_id'];
$engine_url = $conf['engine_url'] ;
$engine_kwd = $conf['engine_kwd'];
$engine_charset = $conf['engine_charset'];
$save_host = $conf['save_host'];

echo "<table class='stat'>
<tr class='title'><td colspan='5'>".$strings['Clickstreamfor']."$ip</td></tr>";

$sql = "SELECT date,page,ref,agent FROM ${table}_host WHERE host='$ip' ORDER BY date ASC";
$res = mysql_query($sql,$c);
$n = 0;
$host = gethostbyaddr($ip);
$country = ip2Country($ip,$ip2c);
if (whoislink($country) == FALSE) {
	$whoislink = "no whois link";
} else {
	$whoislink = "<a href=\"".whoislink($country)."$ip\"  target=\"blank\" class=\"basic\">whois</a>";
}
$baniplink = "";
if ($isLoggedIn) {
	$baniplink = ", <a href=\"index.php?mode=setup&amp;todo=banip&amp;ip=$ip&amp;lang=$lang\" class=\"basic\">".$strings['banIP']."</a>";
}
while($row = mysql_fetch_object($res)) {
	$time = $row->date;
	$referer = $row->ref;
	$thisagent = $row->agent;
	$page = $row->page;
	if ($n==0) {
		$nhits = 0;
		$start = $row->date;
		list($wb,$os)=split(";",phpTrafficA_ExtractAgent($thisagent,$browser_id,$browser_label,$os_id,$os_label));
		$oldagent = $thisagent;
		$echo = "<tr><td valign=\"top\" colspan=\"3\">$ip ($whoislink, <a href=\"http://soft.zoneo.net/phpTrafficA/mapIP.php?ip=$ip\" target=\"blank\" class=\"basic\">".$strings['map']."</a>$baniplink)<br>$host<br><table class=\"basic\"><tr><td>".countryNameFlag($country)."</td></tr></table></td><td valign=\"top\" colspan=\"2\">".$strings['Agent'].": $thisagent<br><table class=\"basic\"><tr><td>".osImgName($os)."</td><td>".browserImgName($wb)."</td></tr></table>".$strings['Referrer'].": ";
		$echo .= formatRefString($referer,$engine_id,$engine_url,$engine_kwd,$engine_charset,"class=\"basic\"");
		$echo .= "</td></tr>\n<tr class=\"caption\"><td colspan=\"5\" class=\"btop\">".$strings['Path']."</td></tr>\n";
		$echo .= "<tr class=\"caption\"><td>&nbsp;</td><td colspan=\"2\">".$strings['Dateandtime']."</td><td>".$strings['Page']."</td><td>".$strings['Referrer']."</td></tr>\n";
	}
	// simple path analysis
	$n += 1;
	$nhits += 1;
	$thisdate = $time;
	$when = getTimeEn(strtotime($time)-strtotime($start));
	$refstring = urlLink($referer,2);
	if (($n % 2) == 0) { $even = "even";} else {$even="odd";}
	$echo .= "<tr class=\"$even data\"><td align=\"center\">$n</td><td>$thisdate</td><td>$when</td><td>$page</td><td>$refstring</td></tr>";
}
echo "$echo\n";
echo "</table>\n";
}

?>
